
(* for the bisimulation problem *)

structure L :> SET =
struct

   (* rep. inv: sorted in ascending order *)
    type set = int list

    val empty = nil
        
    fun insert (a, nil) = [a]
      | insert (a, h::t) =
        if a < h then a :: h :: t
        else h :: insert (a, t)

    fun member (nil, _) = false
      | member (h::t, i) = h = i orelse member (t, i)

    fun smallest nil = NONE
      | smallest (h::_) = SOME h

end