
structure Testcases =
struct
    local 
        open PolyMinML
    in
        val t1 = Int 5

        val t2 = Bool false
            
        val t3 = Unit

        val t4 = Primop (TIMES, map I [Int 0, Int 1])

        val t5 = App (Fun ("f", "x", INT, INT, I (Var "x")), I (Int 0))

        val t6 = If (I (Bool true), Int 1, Int 2)

        val t7 = Typefun ("t", Int 0)

        val t8 = Inst (Typefun ("t", Int 0), BOOL)

        val easy = [t1, t2, t3, t4, t5, t6, t7, t8]

        (* polymorphic identity function *)

        val t9 = Typefun ("t", Fun("f", "x", VAR "t", VAR "t",
                                   I (Var "x")))

        val t10 = App (Inst (t9, ARROW (BOOL, BOOL)),
                       CFun ("g", "x", I(Var "x")))

        val t11 = App (Inst (t9, ARROW(BOOL, BOOL)),
                       CInst t9)

        val t12 = Fun ("f", "x", UNIT, ALL ("t", ARROW(VAR "t", UNIT)),
                       CTypefun("u", CFun ("g", "y", I(Var "x"))))

        val t13 = Fun ("f", "x", UNIT, ALL ("t", ARROW(VAR "t", UNIT)),
                       CTypefun("t", CFun ("g", "y", I(Var "x"))))


        val t14 = App(Inst (t9, ALL ("t", ARROW(VAR "t", VAR "t"))),
                      I t9)

        val t15 = If( CInst (Typefun("t", Bool true)),
                     Int 0, Int 1)

		  val t16 = If( CApp( CInst(Typefun("t",
														Fun("f", "x", VAR "t", VAR "t", I (Var "x")))),
									Bool true), 
							Int 1, 
							Int 0)

        val medium = [t9, t10, t11, t12, t13, t15, t16]

        (* the following should not type-check *)

        val f1 = Fun ("f", "x", UNIT, UNIT, I(Var "g"))
        val f2 = Fun ("f", "x", VAR "t", UNIT, I(Var "x"))

        val f3 = Fun ("f", "x", UNIT, ARROW(UNIT, INT),
                      CInst(Typefun("t", (Fun("g", "y", VAR "t", VAR "t", I (Var "y"))))))

		  val f4 = If( CApp( CInst(Typefun("t",
													  Fun("f", "x", VAR "t", VAR "t", I (Var "x")))),
									Int 5), 
							Int 1, 
							Int 0)


		  val fails = [f1, f2, f3, f4]

    end
end